/*******************************************************************************
 * Copyright(c) 2021 dongke All rights reserved. / Confidential
 * 类的信息：
 *		1.程序名称：
 *		2.功能描述：新建其他出库
 * 编辑履历：
 *		作者				日期					版本				修改内容
 *		姜永辉	 2024年3月22日		     1.00		   	    一览
 *******************************************************************************/
const mixins = require('@/mixins/index.js');
const Constants = require('@/utils/Constants');
const config = require('@/config/config.js')
const util = require('@/utils/util.js')
const app = getApp()
Page({
    mixins: [mixins],
    /**
     * 页面的初始数据
     */
    data: {
        purIdArray: '',//来源单id 
        // 弹出按钮
        buttonList: [{
            name: 'merge',
            title: mixins.$t('save')
        }],
        contentList: [],
        btnFormData: null,
        //弹出pop
        popContent: [{
            code: 'itemQty',
            type: 'step',
            title: mixins.$t('count'),
            required: true
        },
        { code: 'packageBox', type: 'packageBox', title: mixins.$t("packageBox"), },
        {
            code: 'whId',
            name: 'whName',
            title: mixins.$t('warehouseId'),
            type: 'choose',
            urlKey: 'openingInventory'
        },
        {
            code: 'skuSpec',
            title: mixins.$t('goodSpec'),
            type: 'str',
            readonly: true,
        },
        {
            code: 'brandName',
            title: mixins.$t('brandName'),
            type: 'str',
            readonly: true,
        },
        {
            code: 'nonStdCode',
            title: mixins.$t('goodsBatch'),
            tip: mixins.$t('tipPop'),
            type: 'str',
        },
        ],

        cardList: [{
            name: 'main',
            title: mixins.$t('outBoundInfo'),
        },
        {
            name: 'items',
            title: mixins.$t('goodsDetail'),
            info: '(' + mixins.$t('outboundProcessing') + ')',
            color: '#E4002B',
            itemAmt: 0,
            displayNum: 2
        }, {
            name: 'other',
            title: mixins.$t('otherInfo')
        }
        ],

        cardContentList: [
            { code: 'whId', name: 'whName', title: '库区', type: 'choose', }
        ],
        contentObj: {
            main: [
                {
                    code: 'outReason',
                    name: 'outReasonName',
                    type: 'choose',
                    required: true,
                    urlKey: 'chooseStorageOutReason',
                    urlKeyParam: Constants.kindCode.basicOut
                },
                {
                    code: 'staffId',
                    name: 'staffName',
                    title: mixins.$t('responsiblePerson'),
                    type: 'choose',
                    required: true,
                    urlKey: 'chooseStaff'
                }, {
                    code: 'orgId',
                    name: 'orgName',
                    title: mixins.$t('orgId'),
                    type: 'choose',
                    required: true,
                    urlKey: 'chooseOrg'
                },
                {
                    code: 'outDate',
                    name: 'outDate',
                    type: 'date',
                    required: true,
                },
                {
                    code: 'outObject',
                    name: 'outObjectName',
                    title: mixins.$t('outObject'),
                    type: 'choose',
                    urlKey: 'chooseStorageObject'
                },
            ],

            items: [{
                code: 'collectType',
                name: 'collectName',
                type: 'drop',
                dropType: 'collect'
            }, {
                code: 'collectAmount',
                type: 'number',
                title: mixins.$t('totalAmount'),
            }],

            other: [{
                code: 'remarks',
                type: 'textarea',
                title: mixins.$t('remarks'),
                readonly: false
            }, {
                code: 'file',
                type: 'uploader',
                title: mixins.$t('uploader')
            }]
        },
        // 路由
        routeObjName: 'outboundOther',
        table: Constants.tables.outbound,
        // 系统参数
        flgHandleSetting: app.globalData.setting[Constants.settingCode.IVT001] == "true" ? true : false,
        quantityCol: 'outingQty',
        sumAmountCol: 'itemAmt',
        sumQuantityCol: 'outingQty',
    },

    /**
      * @desc : 页面加载数据方法
      * @date : 2024/2/1 15:49
      * @author : 姜永辉
      */
    loadInit() {
        if (this.data.formMode == Constants.formMode.edit) {
            wx.setNavigationBarTitle({
                title: mixins.$t('editOtherOutWh'),
            })
        } else {
            wx.setNavigationBarTitle({
                title: mixins.$t('addOtherOutWh'),
            })
            // 新增
            if (this.data.formData == '{}') {
                this.setData({
                    formData: JSON.stringify({
                        outDate: new Date().toDateStr(),
                        staffId: app.globalData.user.staffId,
                        orgId: app.globalData.user.orgId,
                        staffName: app.globalData.user.staffName,
                        orgName: app.globalData.user.orgName,
                    })
                })
            }
            // 系统参数开启自动办理        
            if (!this.data.flgHandleSetting) {
                this.setData({
                    contentList: [
                        {
                            code: 'need',
                            title: mixins.$t('totalAmount'),
                            type: 'str'
                        },
                        {
                            code: 'amount',
                            content: 0,
                            type: 'number'
                        }],
                })
            } else {
                this.setData({
                    contentList: [
                        {
                            code: 'flag',
                            title: mixins.$t('antoHandle'),
                            type: 'checkbox'
                        }, {
                            code: 'need',
                            title: mixins.$t('totalAmount'),
                            type: 'str'
                        },
                        {
                            code: 'amount',
                            content: 0,
                            type: 'number'
                        }],
                })
                let btnFormData = JSON.parse(this.data.btnFormData) || {}
                btnFormData.flag = true

                this.setData({
                    btnFormData: JSON.stringify(btnFormData),
                })
            }
        }

    },

    /**
    * @desc : 给表单赋值
    * @date : 2024/2/1 15:49
    * @author : 姜永辉
    */
    setValuesByEdit(data) {
        let cardList_ = this.data.cardList
        let sumitemAmt = 0
        let sumitemquantity = 0
        let formType = this.data.formType
        //  出库状态-已出库
        if (data.outStatus == Constants.outStatus.outBounded) {
            //查询采购订单表 未出库的 详细 
            sumitemquantity = Number(data.outQty)
            sumitemAmt = Number(data.outAmt)
            this.setData({
                quantityCol: 'outQty',
                sumQuantityCol: 'outQty',
            })
        } else {
            sumitemquantity = Number(data.outingQty)
            sumitemAmt = Number(data.outingAmt)
            this.setData({
                quantityCol: 'outingQty',
                sumQuantityCol: 'outingQty',
            })
        }
        cardList_.forEach(card => {
            if (card.name === 'items') {
                if (formType == 1) {
                    card.info = "（" + mixins.$t("outboundProcessing") + "）"
                    card.color = "#E4002B"
                } else {
                    card.info = "（" + mixins.$t("checkouted") + "）"
                    card.color = "#1B365D"
                }
                card.itemAmt = sumitemAmt
                //  出库状态-已出库
                if (data.outStatus == Constants.outStatus.outBounded) {
                    card.itemQty = sumitemquantity
                } else {
                    card.outingQty = sumitemquantity
                }
            }
        })

        // 明细的最大出库办理的量
        data.goodsList.forEach(element => {
            //" 已出库"
            if (data.outStatus == Constants.outStatus.outBounded) {
                element.itemAmt = element.priceOut * element.outQty
                element.itemQty = element.outQty
                element.box = element.outBox
                element.piece = element.outPiece
            } else {
                element.itemAmt = element.priceOut * element.outingQty
                element.itemQty = element.outingQty
                element.box = element.outingBox
                element.piece = element.outingPiece
            }
            if (data.outType == Constants.outType.purReturn) {
                element['outingQty_max'] = -1
                if (element.outStatus == Constants.outStatus.outBounded) {
                    element['outingQty_min'] = -1 * Math.abs(element.outQty)
                } else {
                    element['outingQty_min'] = -1 * Math.abs(element.outingQty)
                }
            } else {
                if (data.outStatus == Constants.outStatus.outBounded) {
                    element['outingQty_max'] = element.outQty
                } else {
                    element['outingQty_max'] = element.outingQty
                }

                element['outingQty_min'] = 1
            }
            if (element.skuImages && element.skuImages.length > 0) {
                element.skuImages.forEach(item => {
                    item.url = config.image_url + item.path
                });
                element.imagesUrl = element.skuImages[0].url
            }
            if (element.flgSubUnit) {
                element.calculationFormula = element.packBox + element.unitName + '= 1' + element.subUnitName
                element.packageBox = element['box'] + element.subUnitName + element['piece'] + element.unitName

            }
            // 显示库区和可售量开关
            element.usableQtyInsufficientFlag = true
        })

        // 刷新商品明细 显示 查看更多
        let card = this.data.cardList.filter(it => it.name == 'items');
        this.selectComponent('#' + this.data.formName).handleContentObj(card[0])

        // 系统参数开启自动办理   --编辑的时候都不显示出来 240513 后台不依赖这个参数         
        this.setData({
            contentList: [
                {
                    code: 'need',
                    title: mixins.$t('totalAmount'),
                    type: 'str'
                },
                {
                    code: 'amount',
                    content: sumitemAmt,
                    type: 'number'
                }],
        })

        this.setData({
            itemData: data,
            flgHandleSetting: data.flgHandleSetting,
            flgAutoHandle: data.flgAutoHandle,
            cardList: cardList_,
            formData: JSON.stringify(data),
            sumitemAmt
        })

    },
    /**
     * @desc   : 绑定数据-选择页面返回的逻辑处理
     * @author : 姜永辉
     * @date   : 2024年3月12日
     */
    chooseData(e) {
        let formData = JSON.parse(this.data.formData)
        let cardList_ = this.data.cardList
        let code = e.detail.code
        let data = e.detail.data.data
        if (code == "supId") { //供应商
            formData.supId = data.id
            formData.supName = data.name
        }
        if (code == "staffId") { //员工
            formData.staffId = data.id
            formData.staffName = data.name
            formData.orgId = data.orgId
            formData.orgName = data.orgName
        }
        if (code == "orgId") { //部门
            formData.orgId = data.id
            formData.orgName = data.name
        }
        if (code == "outReason") { //出库原因
            formData.outReason = data.id
            formData.outReasonName = data.name
        }
        if (code == "outObject") { //出库对象
            formData.outObject = data.id
            formData.outObjectName = data.name
            formData.objType = data.objType
        }
        this.setData({
            cardList: cardList_,
            formData: JSON.stringify(formData)
        })
    },

    /**
    * @desc : 外露设置产品方法 
    * @date : 2024/2/1 15:49
    * @author : 姜永辉
    */
    setGoods(e) {
        let contentList_ = this.data.contentList
        let cardList = this.data.cardList
        let formData = JSON.parse(this.data.formData)
        let totalAmout = Number(0)
        let totalQuantity = Number(0)
        // 各个明细的金额数量
        formData.goodsList.forEach(element => {  //循环出商品总共价格 
            //" 已出库"
            if (formData.outStatus == Constants.outStatus.outBounded) {

                element.outQty = element.itemQty
                element.priceOut = element.priceOut ? element.priceOut : element.priceStandard
                element.outAmt = element.priceOut * element.itemQty
                element.outingAmt = 0     //  已出库金额
                element.outingQty = 0     //  已出库数量
                // 显示库区和可售量开关
                element.usableQtyInsufficientFlag = true
                totalAmout += Number(element.priceOut * element.itemQty)
                totalQuantity += Number(element.itemQty)
            } else {
                element.outingQty = element.itemQty
                element.priceOut = element.priceOut ? element.priceOut : element.priceStandard
                element.outingAmt = element.priceOut * element.itemQty
                element.outAmt = 0     //  已出库金额
                element.outQty = 0     //  已出库数量
                // 显示库区和可售量开关
                element.usableQtyInsufficientFlag = true
                totalAmout += Number(element.priceOut * element.itemQty)
                totalQuantity += Number(element.itemQty)
            }
            element.packageBox = element['box'] + element.subUnitName + element['piece'] + element.unitName

        })
        // 左下角的合计金额
        contentList_.forEach(card => {
            if (card.code === 'amount') {
                card.content = totalAmout
            }
        })
        // 明细的合计金额
        cardList.forEach(card => {  //循环出商品总共价格
            if (card.name === 'items') {
                //合计金额
                card.itemAmt = totalAmout
                card.itemQty = totalQuantity
            }
        })
        this.setData({
            contentList: contentList_,
            cardList,
            formData: JSON.stringify(formData)
        })
    },

    /**
     * @desc : 保存数据服务--校验
     * @date : 2024/2/1 15:49
     * @author : 姜永辉
     */
    validData() {
        let formData = JSON.parse(this.data.formData)
        if (formData.goodsList == null || formData.goodsList.length == 0) {
            util.showToast(mixins.$t("chooseGoodsInfo"));
            return false
        }
        // 明细的数量和仓库不能为空
        for (let index = 0; index < formData.goodsList.length; index++) {
            const element = formData.goodsList[index];
            if (element.whId == null) {
                util.showToast(mixins.$t("chooseWh"));
                return false
            }
            if (element.itemQty == null || element.itemQty == '' || element.itemQty == 0) {
                util.showToast(mixins.$t("inputWords") + "[" + element.skuCode + "]" + mixins.$t("count"));
                return false
            }
        }
        return true
    },

    /**
     * @desc : 保存的參數設置
     * @date : 2024/2/1 15:49
     * @author : 姜永辉
     */
    setParams(params) {
        let btnFormData = this.data.btnFormData ? JSON.parse(this.data.btnFormData) : ''
        let formData = JSON.parse(this.data.formData)
        // 新增编辑的
        params.outId = formData.outId
        if (!this.data.flgHandleSetting) {
            params.flgAutoHandle = false
        } else {
            params.flgAutoHandle = btnFormData ? btnFormData.flag : false //自动出入库标识 
        }
        // 总单的 出库中数量和金额合计
        if (formData.outStatus == Constants.outStatus.outBounded) { //已出库
            params.outingAmt = 0  //金额
            params.outingQty = 0 //一共的商品数量
            params.outAmt = formData.goodsList.sum("outAmt") //  已出库金额
            params.outQty = formData.goodsList.sum("outQty") //  已出库数量   
            formData.goodsList.forEach(item => {
                item.outBox = item.box
                item.outPiece = item.piece
            })

        } else { //出库中
            params.outingAmt = formData.goodsList.sum("outingAmt")   //金额
            params.outingQty = formData.goodsList.sum("outingQty")     //一共的商品数量
            params.outAmt = 0     //  已出库金额
            params.outQty = 0     //  已出库数量     
            formData.goodsList.forEach(item => {
                //  新建 直接生成出库单的情况
                if (params.flgAutoHandle) {
                    item.outBox = item.box
                    item.outPiece = item.piece
                } else {
                    item.outingBox = item.box
                    item.outingPiece = item.piece
                }

            })
        }

        // 系统参数
        params.flgHandleSetting = this.data.flgHandleSetting
        //负库存
        params.canNegativeFlag = app.globalData.setting[Constants.settingCode.IVT002] == "true" ? true : false
        // params.fromId = this.data.purIdArray  //来源id
        // params.fromNo = formData.fromNo  //来源单号
        params.orgId = formData.orgId  //组织部门
        params.staffId = formData.staffId  // 员工
        //  // 供应商1 客户2 所有 传空
        if (formData.objType == 1) {
            params.supId = formData.outObject  // 供应商
        }
        if (formData.objType == 2) {
            params.cusId = formData.outObject  // 客户
        }
        // params.whId = formData.whId  // 仓库
        params.remarks = formData.remarks  // 备注
        params.makeStaff = app.globalData.user.staffId  // 制单人
        // 明细的顺序
        let i = 0
        formData.goodsList.forEach(it => {
            it.itemIndex = (i++)
        })
        params.itemList = formData.goodsList //商品明细
        params.annexPaths = formData.annexPaths || [] //附件 
        params.limitEdit = true
        return params
    },

    /**
    * @desc : 保存数据服务
    * @date : 2024/2/1 15:49
    * @author : 姜永辉
    */
    saveData() {
        if (this.data.formMode == Constants.formMode.edit) {
            return this.excute(this.data.service, this.data.service.otheroutBoundUpdate, this.data.params)
        } else {
            return this.excute(this.data.service, this.data.service.otheroutBoundInsert, this.data.params)
        }
    },
})